const Client = require('aliyun-api-gateway').Client;
var RPCClient = require('@alicloud/pop-core').RPCClient;
const system = require("../system");
class aliyunClient {
  constructor() {
    this.execClientNew = system.getObject("util.execClientNew");
    this.pushlogSve = system.getObject("service.common.pushlogSve");
  }
  getAliClient() {
    return new RPCClient({
      accessKeyId: "LTAI1pJs7KQizBe2",//对应的aliuid 是 30039057
      accessKeySecret: "MMNibebAPqR9AnX5YWHnSL2tHMSIoL",
      endpoint: "https://companyreg.aliyuncs.com",
      apiVersion: "2020-03-06"
    });
  }
  getAliTMClient() {
    return new RPCClient({
      accessKeyId: 'LTAI4FmyipY1wuLHjLhMWiPa', //对应的aliuid 是 1525276744866147
      accessKeySecret: 'hp4FF18IDCSym1prqzxrAjnnhNH3ju',
      endpoint: 'https://trademark.aliyuncs.com',
      apiVersion: '2018-07-24'
    }
    );
  }

  // 2020 0924 lin 新增 调用阿里网关账号
  getAliLTClient() {
    return new RPCClient({
      accessKeyId: "LTAI4GFpXoAvKbJSCmJXFfR9",//对应的aliuid 是 30039057
      accessKeySecret: "TBYUHMEkvDtwxSttf60GcVuh6ieADQ",
      endpoint: "https://companyreg.aliyuncs.com",
      apiVersion: "2020-03-06"
    });
  }

  async post(aliReqUrl, key, secret, actionBody) {
    const client = new Client(key, secret);
    var param = {
      data: actionBody,
      timeout: 20000,
      headers: {
        accept: 'application/json'
      }
    };
    console.log(JSON.stringify(param), "______________峰擎---阿里云参数_______");
    var result = await client.post(aliReqUrl, param);
    console.log(JSON.stringify(result), "______________峰擎---阿里云返回结果_______");
    return result;
  }
  //阿里接口
  async reqbyget(obj, cbk) {
    var action = obj.action;
    var reqbody = obj.reqbody;
    var self=this;
    try {
      var reqAliclient = null;// { ... this.aliclient };
      if(obj.type && obj.type =="TM"){
        reqAliclient=self.getAliTMClient();
      }else{
        reqAliclient=self.getAliClient();
      }
      if (obj.apiVersion) {
        reqAliclient.apiVersion = obj.apiVersion;
      }
      var res = await reqAliclient.request(action, reqbody, {
        timeout: 10000, // default 3000 ms 2020 0916 lin修改3000为10000，原因ConfirmIcpIntention BizIds 超过5条会超时
        formatAction: true, // default true, format the action to Action
        formatParams: true, // default true, format the parameter name to first letter upper case
        method: 'GET', // set the http method, default is GET
        headers: {}, // set the http request headers
      });
      this.pushlogSve.createDb({
        op: "old-reqbyget",
        content: JSON.stringify(obj),//推送的参数信息
        resultInfo: JSON.stringify(res),
        returnType: '1',
        logLevel: '1',
        opTitle: "old-reqbyget推送阿里信息返回成功"
      });
      return system.getResultSuccess(res);
    } catch (e) {
      this.pushlogSve.createFailLogDb({
        appid: obj.appInfo ? obj.appInfo.uapp_id || "" : "",
        appkey: obj.appInfo ? obj.appInfo.uapp_key || "" : "",
        requestId: obj.requestId || "",
        content: JSON.stringify(obj),//推送的参数信息
        resultInfo: "error:" + JSON.stringify(e),
        clientIp: obj.clientIp || "",
        failType: 1,
        opTitle: "old-reqbyget推送阿里信息返回异常",
        pushNumber: obj.pushNumber || 1
      });
      return system.getResultFail(-200, "出现异常，error：" + e.stack);
    }
  }

  //-----------阿里云双呼能力接口接入------start--------chensicong----2022.01.17----------------------

  // 专家辅助申请（商标注册） 双呼客户端
  getAliDoubleCallClientForTMREG() {
    return new RPCClient({
      accessKeyId: "LTAI1pJs7KQizBe2",//对应的aliuid 是 30039057
      accessKeySecret: "MMNibebAPqR9AnX5YWHnSL2tHMSIoL",
      endpoint: "https://companyreg.aliyuncs.com",
      apiVersion: "2020-03-06"
    });
  }

  // 商标交易（商标优选） 双呼客户端
  getAliDoubleCallClientForTMTRADE() {
    return new RPCClient({
      accessKeyId: 'LTAI4FmyipY1wuLHjLhMWiPa', // 对应的aliuid 是 1525276744866147
      accessKeySecret: 'hp4FF18IDCSym1prqzxrAjnnhNH3ju',
      endpoint: "https://companyreg.aliyuncs.com",
      apiVersion: "2020-03-06"
    });
  }

  // 获取可用外呼号码列表
  async queryAvailabelNumbers(bizType){
    let res = null;
    try{
      console.log(`开始调用阿里云-获取可用外呼号码列表接口。参数bizType=${bizType}`)
      if(!bizType){
        return system.getResultFail(-200, "bizType不能为空");
      }

      let reqAliclient = null
      if(bizType == 'TM_TRADE'){
        reqAliclient = this.getAliDoubleCallClientForTMTRADE();
      }else if(bizType == 'EXPERT_APPLY'){
        reqAliclient = this.getAliDoubleCallClientForTMREG();
      }else {
        return system.getResultFail(-200, `不支持的bizType=${bizType}`);
      }


      let obj = { bizType:bizType }
      res = await reqAliclient.request("QueryAvailableNumbers", obj, {
        timeout: 3000, // default 3000 ms
        formatAction: true, // default true, format the action to Action
        formatParams: true, // default true, format the parameter name to first letter upper case
        method: 'POST', // set the http method, default is GET
        headers: {}, // set the http request headers
      });
      console.log(`结束调用阿里云-获取可用外呼号码列表接口。参数bizType=${bizType}，结果=${JSON.stringify(res)}`)
      this.execClientNew.execLogs(`获取可用外呼号码列表成功`, {bizType:bizType}, "center-channel-aliyunClient-queryAvailabelNumbers", res, null);
      return system.getResultSuccess(res.Data||res.data);
    }catch (e){
      console.log(`调用异常：阿里云-获取可用外呼号码列表接口。参数bizType=${bizType}，结果=${JSON.stringify(res)},异常信息=${e.stack}`)
      this.execClientNew.execLogs(`获取可用外呼号码列表失败接口`, {bizType:bizType}, "center-channel-aliyunClient-queryAvailabelNumbers", res, JSON.stringify(e.stack));
      return system.getResultFail(-200, "api调用出现异常，error：" + e.stack);
    }
  }

  /**
   * 发起双呼
   * @param reqbody
   * @returns {Promise<{msg: *, data: *, status: *}|{msg: *, data, status: number}>}
   */
  async startBackToBackCall(reqbody){
    let res = null;
    try{
      console.log(`开始调用阿里云-发起双呼接口。参数reqbody`,reqbody)

      if(!reqbody.bizType){
        return system.getResultFail(-200, "bizType不能为空");
      }

      let reqAliclient = null
      if(reqbody.bizType == 'TM_TRADE'){
        reqAliclient = this.getAliDoubleCallClientForTMTRADE();
      }else if(reqbody.bizType == 'EXPERT_APPLY'){
        reqAliclient = this.getAliDoubleCallClientForTMREG();
      }else {
        return system.getResultFail(-200, `不支持的bizType=${reqbody.bizType}`);
      }
      res = await reqAliclient.request("StartBackToBackCall",reqbody, {
        timeout: 10000, // default 3000 ms 2020 0916 lin修改3000为10000，原因ConfirmIcpIntention BizIds 超过5条会超时
        formatAction: true, // default true, format the action to Action
        formatParams: true, // default true, format the parameter name to first letter upper case
        method: 'POST', // set the http method, default is GET
        headers: {}, // set the http request headers
      });
      console.log(`结束调用阿里云-发起双呼接口。参数reqbody=`,reqbody,'结果=',JSON.stringify(res))
      this.execClientNew.execLogs(`调用阿里云发起双呼接口成功`, reqbody, "center-channel-aliyunClient-startBackToBackCall", res, null);
      return system.getResultSuccess(res.Data||res.data);
    }catch (e){
      console.log(`调用异常：阿里云-发起双呼接口。参数reqbody=`,reqbody,'结果=',JSON.stringify(res),`异常信息=${e.stack}`)
      this.execClientNew.execLogs(`调用阿里云发起双呼接口失败`, reqbody, "center-channel-aliyunClient-startBackToBackCall", res, JSON.stringify(e.stack));
      return system.getResultFail(-200, "api调用出现异常，error：" + JSON.stringify(e.data));
    }
  }

  //-----------阿里云双呼能力接口接入------start--------chensicong----2022.01.17----------------------


// 2020 0924 lin 新增 
async reqbyLTget(obj, cbk) {
  var action = obj.action;
  var reqbody = obj.reqbody;
  var self=this;
  try {
    var reqAliclient = self.getAliLTClient();
    if (obj.apiVersion) {
      reqAliclient.apiVersion = obj.apiVersion;
    }
    var res = await reqAliclient.request(action, reqbody, {
      timeout: 10000, // default 3000 ms 2020 0916 lin修改3000为10000，原因ConfirmIcpIntention BizIds 超过5条会超时
      formatAction: true, // default true, format the action to Action
      formatParams: true, // default true, format the parameter name to first letter upper case
      method: 'GET', // set the http method, default is GET
      headers: {}, // set the http request headers
    });
    this.pushlogSve.createDb({
      op: "old-reqbyget",
      content: JSON.stringify(obj),//推送的参数信息
      resultInfo: JSON.stringify(res),
      returnType: '1',
      logLevel: '1',
      opTitle: "old-reqbyget推送阿里信息返回成功"
    });
    return system.getResultSuccess(res);
  } catch (e) {
    this.pushlogSve.createFailLogDb({
      appid: obj.appInfo ? obj.appInfo.uapp_id || "" : "",
      appkey: obj.appInfo ? obj.appInfo.uapp_key || "" : "",
      requestId: obj.requestId || "",
      content: JSON.stringify(obj),//推送的参数信息
      resultInfo: "error:" + JSON.stringify(e),
      clientIp: obj.clientIp || "",
      failType: 1,
      opTitle: "old-reqbyget推送阿里信息返回异常",
      pushNumber: obj.pushNumber || 1
    });
    return system.getResultFail(-200, "出现异常，error：" + e.stack);
  }
}

  async reqCustomByGet(obj, cbk) {
    var action = obj.action;
    var reqbody = obj.reqbody;
    var rpcParam = obj.rpcParam;
    var reqAliclient = this.getAliClient();// { ...self.aliclient };
    if (rpcParam.accessKeyId) {
      reqAliclient.accessKeyId = rpcParam.accessKeyId;
    }
    if (rpcParam.accessKeySecret) {
      reqAliclient.accessKeySecret = rpcParam.accessKeySecret;
    }
    if (rpcParam.endpoint) {
      reqAliclient.endpoint = rpcParam.endpoint;
    }
    if (rpcParam.apiVersion) {
      reqAliclient.apiVersion = rpcParam.apiVersion;
    }
    var res = await reqAliclient.request(action, reqbody, {
      timeout: 3000, // default 3000 ms
      formatAction: true, // default true, format the action to Action
      formatParams: true, // default true, format the parameter name to first letter upper case
      method: 'GET', // set the http method, default is GET
      headers: {}, // set the http request headers
    });
    console.log(action, "action...........");
    console.log(reqbody, "reqbody...........");
    return system.getResultSuccess(res);
  }
  // async reqCustomByPost(obj, cbk) {
  //   var action = obj.action;
  //   var reqbody = obj.reqbody;
  //   var rpcParam = obj.rpcParam;
  //   var reqAliclient = { ... this.aliclient };
  //   if (rpcParam.accessKeyId) {
  //     reqAliclient.accessKeyId = rpcParam.accessKeyId;
  //   }
  //   if (rpcParam.accessKeySecret) {
  //     reqAliclient.accessKeySecret = rpcParam.accessKeySecret;
  //   }
  //   if (rpcParam.endpoint) {
  //     reqAliclient.endpoint = rpcParam.endpoint;
  //   }
  //   if (rpcParam.apiVersion) {
  //     reqAliclient.apiVersion = rpcParam.apiVersion;
  //   }
  //   var res = await reqAliclient.request(action, reqbody, {
  //     timeout: 3000, // default 3000 ms
  //     formatAction: true, // default true, format the action to Action
  //     formatParams: true, // default true, format the parameter name to first letter upper case
  //     method: 'POST', // set the http method, default is GET
  //     headers: {}, // set the http request headers
  //   });
  //   return system.getResultSuccess(res);
  // }
}
module.exports = aliyunClient;
